#!/bin/bash -e

set -x
SOURCE_ROOT=gzip-1.3.12
TAR_BALL=${SOURCE_ROOT}.tar.gz

if [ $# -ne 1 ]; then
    echo "for compilation and installation usage ./build.sh mips|arm1176"
    echo "for cleaning ./build.sh clean "
    exit 1
fi

OPTION=$1

if [ $OPTION = clean ] 
then
        pushd .
        cd ${SOURCE_ROOT}
	make -f Makefile.opera clean
        popd
	rm -rf $SOURCE_ROOT
else
	if [ -e gzip-1.3.12 ] ; then
                echo "Run ./build.sh clean"
                exit
        fi
        BUILD_ARCH=$1
        if [ "$BUILD_ARCH" != "arm1176" -a "$BUILD_ARCH" != "mips" -a "$BUILD_ARCH" != "arm" ] ; then
                echo "Build target $BUILD_ARCH not supported"
                exit
        fi

        tar xvzf ${TAR_BALL}
	cp Makefile.opera ${SOURCE_ROOT}
        pushd .
        cd ${SOURCE_ROOT}
	#################################
	#    patch files are created in this top-level dir via
	#       diff -urN gzip-1.3.12/original_source.c  gzip-1.3.12/modified_source.c > patches/patch_file
	#    and can be applied via
	#	patch -p1 < ../anyrequired.patch
	#################################
	make -f Makefile.opera OPERA_TARGET=$BUILD_ARCH
        popd
fi
